<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8">
    <title>Scan & Highlight Data Pesanan</title>
    <meta http-equiv="Content-Security-Policy" content="script-src 'self' 'unsafe-inline';" />
    <link href="./assets/lib/@fortawesome/fontawesome-free/css/all.min.css" rel="stylesheet">
    <link href="./assets/lib/ionicons/css/ionicons.min.css" rel="stylesheet">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:400,300,100,500,700,900">
    <link rel="stylesheet" href="./assets/lib/@fortawesome/fontawesome-free/css/all.min.css">
    <link rel="stylesheet" href="./assets/lib/ionicons/css/ionicons.min.css">
    <link rel="stylesheet" href="./assets/lib/datatables.net-dt/css/jquery.dataTables.min.css">
    <link rel="stylesheet" href="./assets/lib/bootstrap-datepicker/bootstrap-datepicker.min.css">
    <link rel="stylesheet" href="./assets/css/dashforge.css">
    <link rel="stylesheet" href="./assets/css/dashforge.auth.css">
    <link rel="stylesheet" href="./assets/css/skin.charcoal.css">
    <style>
      body {
        /* background-color: #f5f6fa; */
        background-color: #EEEEEE;
        user-select: none; /* supported by Chrome and Opera */
        -webkit-user-select: none; /* Safari */
        -moz-user-select: none; /* Firefox */
        -ms-user-select: none;
      }
      input[type="search"] {
          border-radius: 0px !important;
      }
      *:focus:not(.btn) {
          border-color: inherit !important;
          -webkit-box-shadow: none !important;
          box-shadow: none !important;
          outline: #3b4863 !important;
      }
      .card {
          border-radius: 0px;
      }
      .cursor-pointer {
          cursor: pointer !important;
      }
      .bottom-shadow {
          -webkit-box-shadow: 0 8px 6px -6px #EEE;
          -moz-box-shadow: 0 8px 6px -6px #EEE;
          box-shadow: 0 8px 6px -6px #EEE;
      }
      .top-shadow {
          -webkit-box-shadow: 0 -8px 6px -6px #EEE;
          -moz-box-shadow: 0 -8px 6px -6px #EEE;
          box-shadow: 0 -8px 6px -6px #EEE;
      }
      .swal2-popup, .swal2-confirm {
          border-radius: 0 !important;
      }
      .text-wrap-overflow {
        white-space: nowrap !important; 
        overflow: hidden !important;
        max-width: 400px;
        width: 400px !important;
        text-overflow: ellipsis !important; 
      }
      .table-hover tbody tr {
          cursor: pointer !important;
      }
    </style>
  </head>
  <body>

    <div class="content ht-100v pd-0">
      <div id="main-content" class="content-body">
        <div class="container pd-x-0">
          <div class="row row-xs">                                                              
            <div class="col-lg-12 col-xl-12">
              <div class="card rounded-0 shadow-sm">
                <div class="card-header pd-t-20 d-sm-flex align-items-start justify-content-between bd-b-0 pd-b-0">
                  <div>
                    <h6 id="RVD_ModuleTitle" class="mg-b-5 text-capitalize"></h6>
                    <p class="tx-13 tx-color-03 mg-b-0">Perubahan data terakhir pada <strong>2020-09-06 23:02:42 WIB</strong></p>
                  </div>
                  <div class="d-flex mg-t-20 mg-sm-t-0">
                    <div class="btn-group flex-fill">
                      <a id="RVD_Reset" class="btn btn-danger rounded-0 text-white"><i class="fa fa-stop-circle"></i> Reset</a>
                      <a id="RVD_Scan" class="btn btn-primary rounded-0 text-white ml-1"><i class="fa fa-barcode"></i> Scan</a>
                      <div class="dropdown show ml-1">
                        <a class="btn btn-primary dropdown-toggle rounded-0" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            <i class="fa fa-list"></i> Menu
                        </a>
                      
                        <div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
                          <a id="RVD_Download" class="dropdown-item">Unduh Laporan Harian</a>
                          <a id="RVD_Import" class="dropdown-item" data-toggle="modal" data-target="#RVD_ModalImport">Impor</a>
                          <a id="RVD_DTBRefresh" class="dropdown-item">Segarkan</a>
                          <div class="dropdown-divider"></div>
                          <a id="RVD_ShowModuleOrder" class="dropdown-item">Data Pesanan</a>
                          <a id="RVD_ShowModuleStore" class="dropdown-item">Data Toko</a>
                          <a id="RVD_ShowModuleCourier" class="dropdown-item">Data Kurir</a>
                        </div>
                      </div>
                      <button id="RVD_Exit" class="btn btn-secondary rounded-0 btn-xs ml-4"><i class="fa fa-sign-out-alt"></i> Tutup</button>
                    </div>
                  </div>
                </div>
                <div class="card-body pd-y-30">
                  <div id="RVD_ModuleOrder" class="mb-2 d-none">
                    <table id="RVD_Order" class="table table-bordered table-striped table-primary table-hover table-sm" width="100%">
                      <thead>
                        <tr>
                          <th class="text-center">#</th>
                          <th class="text-center">Nama Pembeli</th>
                          <th class="text-center">Produk</th>
                          <th class="text-center">No. Resi</th>
                          <th class="text-center">Ongkir</th>
                          <th class="text-center">Kurir</th>
                        </tr>
                      </thead>
                    </table>
                  </div>
                  <div id="RVD_ModuleStore" class="mb-2 d-none">
                    <table id="RVD_Store" class="table table-bordered table-striped table-primary table-hover table-sm" width="100%">
                      <thead>
                        <tr>
                          <th class="text-center">#</th>
                          <th class="text-center">ID</th>
                          <th class="text-center">Nama Toko</th>
                        </tr>
                      </thead>
                    </table>
                  </div>
                  <div id="RVD_ModuleCourier" class="mb-2 d-none">
                    <table id="RVD_Courier" class="table table-bordered table-striped table-primary table-hover table-sm" width="100%">
                      <thead>
                        <tr>
                          <th class="text-center">#</th>
                          <th class="text-center">ID</th>
                          <th class="text-center">Nama Kurir</th>
                        </tr>
                      </thead>
                    </table>
                  </div>
                  <div class="col-4 float-left pd-l-0-f">
                    <a id="RVD_AddModalByModule" class="btn btn-primary rounded-0 text-white" data-toggle="modal"><i class="fa fa-plus"></i> Tambah Data</a>
                  </div>
                  <div class="col-8 float-right pd-r-0-f">
                    <input id="RVD_ScanInput" class="form-control form-control-sm rounded-0 d-none" placeholder="Pindai barcode disini ....">
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="modal fade" id="RVD_ModalImport" tabindex="-1" role="dialog" aria-labelledby="RVD_ModalImport" aria-hidden="true" data-backdrop="static" data-keyboard="false">
        <form id="RVD_FormImport" method="post" enctype="multipart/form-data" autocomplete="off">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content rounded-0">
                    <div class="modal-header">
                        <h6 class="modal-title">Impor Data Pesanan</h6>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="form-row">
                            <div class="form-group col-12">
                                <label class="d-block mb-0">Unggah File</label>
                                <input type="file" name="excelfile" class="form-control rounded-0" required>
                                <small>File harus berformat .xlsx. Gunakan template untuk format yang lebih sesuai.</small>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-sm btn-secondary rounded-0 mr-0 float-right" data-dismiss="modal"><i class="fa fa-ban"></i> Batal</button>
                        <button type="button" id="RVD_DoImport" class="btn btn-sm btn-primary rounded-0" tabindex="9"><i class="fa fa-check-circle"></i> Impor</button>
                    </div>
                </div>
            </div>
        </form>
    </div>

    <div class="modal fade" id="RVD_ModalAdd" tabindex="-1" role="dialog" aria-labelledby="RVD_ModalAdd" aria-hidden="true" data-backdrop="static" data-keyboard="false">
      <form class="input-transaction" autocomplete="off">
          <div class="modal-dialog modal-dialog-centered" role="document">
              <div class="modal-content rounded-0">
                  <div class="modal-header">
                      <h6 class="modal-title">Buat Data Pesanan</h6>
                      <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                          <span aria-hidden="true">&times;</span>
                      </button>
                  </div>
                  <div class="modal-body">
                      <form>
                          <div class="form-row">
                              <div class="form-group col-md-12">
                                  <label>Nama Pembeli</label>
                                  <input type="text" id="input-name" class="form-control rounded-0" autofocus required>
                              </div>
                          </div>
                          <div class="form-row">
                              <div class="form-group col-md-6">
                                  <label>Nomor Invoice</label>
                                  <input type="text" id="input-invoice" class="form-control rounded-0 text-uppercase-type" required>
                              </div>
                              <div class="form-group col-md-6">
                                  <label>Nomor Barcode</label>
                                  <input type="text" id="input-barcode" class="form-control rounded-0 text-uppercase-type">
                              </div>
                          </div>
                          <div class="form-row">
                              <div class="form-group col-md-12">
                                  <label>Deskripsi Produk</label>
                                  <textarea id="input-descproduct" class="form-control rounded-0" rows="4" required></textarea>
                              </div>
                          </div>
                          <div class="form-row">
                              <div class="form-group col-md-4">
                                  <label>Tanggal Pesan</label>
                                  <input type="text" id="input-dateorder" class="form-control rounded-0 set-datepicker-custom">
                              </div>
                              <div class="form-group col-md-4">
                                  <label>Pilih Kurir</label>
                                  <select class="custom-select rounded-0 text-uppercase input-courier" required>
                                  </select>
                              </div>
                              <div class="form-group col-md-4">
                                  <label>Pilih Toko</label>
                                  <select class="custom-select rounded-0 text-uppercase input-ecommerce" required>
                                  </select>
                              </div>
                          </div>
                          <div class="form-row">
                              <div class="form-group col-md-4">
                                  <label>Kota Tujuan</label>
                                  <input type="text" id="input-city" class="form-control rounded-0">
                              </div>
                              <div class="form-group col-md-4">
                                  <label>Tanggal Kirim</label>
                                  <input type="text" id="input-dateshipping" class="form-control rounded-0 set-datepicker-custom">
                              </div>
                              <div class="form-group col-md-4">
                                  <label>Ongkos Kirim</label>
                                  <input type="number" id="input-fee" class="form-control text-right rounded-0">
                              </div>
                          </div>
                          <div class="form-row">
                              <div class="form-group col-md-12">
                                  <label>Nomor Telepon</label>
                                  <input type="text" id="input-phone" class="form-control rounded-0">
                              </div>
                          </div>
                      </form>
                  </div>
                  <div class="modal-footer">
                      <button type="button" class="btn btn-sm btn-secondary rounded-0 mr-0 float-right" data-dismiss="modal"><i class="fa fa-ban"></i> Batal</button>
                      <button type="button" id="RVD_Add" class="btn btn-sm btn-primary rounded-0" tabindex="9"><i class="fa fa-check-circle"></i> Simpan</button>
                  </div>
              </div>
          </div>
      </form>
    </div>

    <div class="modal fade" id="RVD_ModalAddStore" tabindex="-1" role="dialog" aria-labelledby="RVD_ModalAddStore" aria-hidden="true" data-backdrop="static" data-keyboard="false">
        <form class="input-transaction" autocomplete="off">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content rounded-0">
                    <div class="modal-header">
                        <h6 class="modal-title">Buat Data Toko</h6>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="form-row">
                                <div class="form-group col-md-12">
                                    <label>Nama Toko</label>
                                    <input type="text" id="input-name" class="form-control rounded-0" autofocus required>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-sm btn-secondary rounded-0 mr-0 float-right" data-dismiss="modal"><i class="fa fa-ban"></i> Batal</button>
                        <button type="button" id="RVD_AddStore" class="btn btn-sm btn-primary rounded-0" tabindex="9"><i class="fa fa-check-circle"></i> Simpan</button>
                    </div>
                </div>
            </div>
        </form>
      </div>

      <div class="modal fade" id="RVD_ModalStoreDetail" tabindex="-1" role="dialog" aria-labelledby="RVD_ModalStoreDetail" aria-hidden="true" data-backdrop="static" data-keyboard="false">
        <form class="input-transaction" autocomplete="off">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content rounded-0">
                    <div class="modal-header">
                        <h6 class="modal-title">Detail Data Toko</h6>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="form-row">
                                <div class="form-group col-md-12">
                                    <label>Nama Toko</label>
                                    <input type="text" id="input-name" class="form-control rounded-0" autofocus required>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <input type="hidden" id="_storeid"/>
                        <button type="button" class="btn btn-sm btn-secondary rounded-0 mr-0 float-right" data-dismiss="modal"><i class="fa fa-ban"></i> Batal</button>
                        <button type="button" id="RVD_UpdateStore" class="btn btn-sm btn-primary rounded-0" tabindex="9"><i class="fa fa-check-circle"></i> Simpan</button>
                    </div>
                </div>
            </div>
        </form>
      </div>

      <div class="modal fade" id="RVD_ModalAddCourier" tabindex="-1" role="dialog" aria-labelledby="RVD_ModalAddCourier" aria-hidden="true" data-backdrop="static" data-keyboard="false">
        <form class="input-transaction" autocomplete="off">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content rounded-0">
                    <div class="modal-header">
                        <h6 class="modal-title">Buat Data Kurir</h6>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="form-row">
                                <div class="form-group col-md-12">
                                    <label>Nama Kurir</label>
                                    <input type="text" id="input-name" class="form-control rounded-0" autofocus required>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-sm btn-secondary rounded-0 mr-0 float-right" data-dismiss="modal"><i class="fa fa-ban"></i> Batal</button>
                        <button type="button" id="RVD_AddCourier" class="btn btn-sm btn-primary rounded-0" tabindex="9"><i class="fa fa-check-circle"></i> Simpan</button>
                    </div>
                </div>
            </div>
        </form>
      </div>

      <div class="modal fade" id="RVD_ModalCourierDetail" tabindex="-1" role="dialog" aria-labelledby="RVD_ModalStoreDetail" aria-hidden="true" data-backdrop="static" data-keyboard="false">
        <form class="input-transaction" autocomplete="off">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content rounded-0">
                    <div class="modal-header">
                        <h6 class="modal-title">Detail Data Kurir</h6>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="form-row">
                                <div class="form-group col-md-12">
                                    <label>Nama Kurir</label>
                                    <input type="text" id="input-name" class="form-control rounded-0" autofocus required>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <input type="hidden" id="_courierid"/>
                        <button type="button" class="btn btn-sm btn-secondary rounded-0 mr-0 float-right" data-dismiss="modal"><i class="fa fa-ban"></i> Batal</button>
                        <button type="button" id="RVD_UpdateCourier" class="btn btn-sm btn-primary rounded-0" tabindex="9"><i class="fa fa-check-circle"></i> Simpan</button>
                    </div>
                </div>
            </div>
        </form>
      </div>

    <div class="modal fade" id="RVD_ModalDetail" tabindex="-1" role="dialog" aria-labelledby="RVD_ModalDetail" aria-hidden="true" data-backdrop="static" data-keyboard="false">
        <form class="input-transaction" autocomplete="off">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content rounded-0">
                    <div class="modal-header">
                        <h6 class="modal-title">Detail Data Pesanan</h6>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="form-row">
                                <div class="form-group col-md-12">
                                    <label>Nama Pembeli</label>
                                    <input type="text" id="input-name" class="form-control rounded-0" autofocus required>
                                </div>
                            </div>
                            <div class="form-row">
                                <div class="form-group col-md-6">
                                    <label>Nomor Invoice</label>
                                    <input type="text" id="input-invoice" class="form-control rounded-0 text-uppercase-type" required>
                                </div>
                                <div class="form-group col-md-6">
                                    <label>Nomor Barcode</label>
                                    <input type="text" id="input-barcode" class="form-control rounded-0 text-uppercase-type">
                                </div>
                            </div>
                            <div class="form-row">
                                <div class="form-group col-md-12">
                                    <label>Deskripsi Produk</label>
                                    <textarea id="input-descproduct" class="form-control rounded-0" rows="4" required></textarea>
                                </div>
                            </div>
                            <div class="form-row">
                                <div class="form-group col-md-4">
                                    <label>Tanggal Pesan</label>
                                    <input type="text" id="input-dateorder" class="form-control rounded-0 set-datepicker-custom">
                                </div>
                                <div class="form-group col-md-4">
                                    <label>Pilih Kurir</label>
                                    <select class="custom-select rounded-0 text-uppercase input-courier" required>
                                    </select>
                                </div>
                                <div class="form-group col-md-4">
                                    <label>Pilih Toko</label>
                                    <select class="custom-select rounded-0 text-uppercase input-ecommerce" required>
                                    </select>
                                </div>
                            </div>
                            <div class="form-row">
                                <div class="form-group col-md-4">
                                    <label>Kota Tujuan</label>
                                    <input type="text" id="input-city" class="form-control rounded-0">
                                </div>
                                <div class="form-group col-md-4">
                                    <label>Tanggal Kirim</label>
                                    <input type="text" id="input-dateshipping" class="form-control rounded-0 set-datepicker-custom">
                                </div>
                                <div class="form-group col-md-4">
                                    <label>Ongkos Kirim</label>
                                    <input type="number" id="input-fee" class="form-control text-right rounded-0">
                                </div>
                            </div>
                            <div class="form-row">
                                <div class="form-group col-md-12">
                                    <label>Nomor Telepon</label>
                                    <input type="text" id="input-phone" class="form-control rounded-0">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <input type="hidden" id="_orderid"/>
                        <button type="button" class="btn btn-sm btn-secondary rounded-0 mr-0 float-right" data-dismiss="modal"><i class="fa fa-ban"></i> Batal</button>
                        <button type="button" id="RVD_Update" class="btn btn-sm btn-primary rounded-0" tabindex="9"><i class="fa fa-check-circle"></i> Perbarui</button>
                    </div>
                </div>
            </div>
        </form>
    </div>

    <script>window.$ = window.jQuery = require('jquery');</script>
    <script>const remote = require('electron').remote</script>
    <script src="./assets/lib/jquery/jquery.min.js"></script>
    <script src="./assets/lib/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="./assets/lib/feather-icons/feather.min.js"></script>
    <script src="./assets/lib/perfect-scrollbar/perfect-scrollbar.min.js"></script>
    <script src="./assets/js/jquery.input-mask.min.js"></script>
    <script src="./assets/lib/datatables.net/js/jquery.dataTables.min.js"></script>
    <script src="./assets/lib/jquery.flot/jquery.flot.js"></script>
    <script src="./assets/lib/jquery.flot/jquery.flot.stack.js"></script>
    <script src="./assets/lib/jquery.flot/jquery.flot.resize.js"></script>
    <script src="./assets/lib/bootstrap-datepicker/bootstrap-datepicker.min.js"></script>
    <script src="./assets/lib/bootstrap-datepicker/bootstrap-datepicker.id.min.js"></script>
    <script src="./assets/js/sweetalert.min.js"></script>
    <script src="./assets/js/dashforge.js"></script>
    <script src="./assets/js/libraries.js"></script>
    <script>
      const DOM_Order = $("table#RVD_Order"),
            DOM_Store = $("table#RVD_Store"),
            DOM_Courier = $("table#RVD_Courier"),
            DOM_MOrder  = $("div#RVD_ModuleOrder"),
            DOM_MCourier= $("div#RVD_ModuleCourier"),
            DOM_MStore  = $("div#RVD_ModuleStore"),
            DOM_SMOrder  = $("a#RVD_ShowModuleOrder"),
            DOM_SMCourier= $("a#RVD_ShowModuleCourier"),
            DOM_SMStore  = $("a#RVD_ShowModuleStore"),
            DOM_AddModalByModule = $("a#RVD_AddModalByModule"),
            DOM_Scan  = $("a#RVD_Scan"),
            DOM_Exit  = $("button#RVD_Exit"),
            DOM_Import= $("button#RVD_DoImport"),
            DOM_Download    = $("a#RVD_Download"),
            DOM_Reset       = $("a#RVD_Reset"),
            DOM_ModalImport = $("div#RVD_ModalImport"),
            DOM_ModalAdd    = $("div#RVD_ModalAdd"),
            DOM_ModalAddStore= $("div#RVD_ModalAddStore"),
            DOM_ModalAddCourier= $("div#RVD_ModalAddCourier"),
            DOM_ModalDetail = $("div#RVD_ModalDetail"),
            DOM_ModalStoreDetail = $("div#RVD_ModalStoreDetail"),
            DOM_ModalCourierDetail = $("div#RVD_ModalCourierDetail"),
            DOM_ScanInput   = $("input#RVD_ScanInput"),
            DOM_DTBRefresh  = $("#RVD_DTBRefresh"),
            DTB_Order = DOM_Order.DataTable(FGenerateDataTable('http://localhost:8000/orders/',null,
            [
                {"className": "text-capitalize text-center","data": "orderid","width":"15px","orderable":true},
                {"className": "text-capitalize text-left","data":"customer_name","orderable":true},
                {"className": "text-capitalize text-left text-wrap-overflow","data":"product_raw","width":"100px","orderable":true},
                {"className": "text-capitalize text-right","data": function(data){
                  return '(' + data.storeword + ') ' + data.invoice_number
                },"width":"250px","orderable":true},
                {"className": "text-capitalize text-right","data":"shipping_fee","width":"80px","orderable":true},
                {"className": "text-capitalize text-right","data":"courierword","width":"100px","orderable":true},
            ], function(row,data,index){
                if(data.is_scanned === 1){
                    $(row).find('td').addClass("bg-danger text-white");
                }
            })),
            DTB_Store = DOM_Store.DataTable(FGenerateDataTable('http://localhost:8000/stores/',null,
            [
                {"className": "text-capitalize text-center","data": "storeid","width":"75px","orderable":true},
                {"className": "text-capitalize text-left","data":"storeid","width":"100px","orderable":true},
                {"className": "text-capitalize text-left","data":"storename","orderable":true},
            ],false,false,10)),
            DTB_Courier = DOM_Courier.DataTable(FGenerateDataTable('http://localhost:8000/couriers/',null,
            [
                {"className": "text-capitalize text-center","data": "courierid","width":"75px","orderable":true},
                {"className": "text-capitalize text-left","data":"courierid","width":"100px","orderable":true},
                {"className": "text-capitalize text-left","data":"couriername","orderable":true},
            ],false,false,10));


      $('.text-uppercase-type').upperCase();
      $('.text-capitalize-type').upperFirstAll();
      $('.text-lowercase').lowerCase();
      $('.set-datepicker-custom').datepicker({
          todayHighlight: true,
          autoclose: true,
          language: 'id',
          format: 'yyyy-mm-dd'
      });

      DOM_MOrder.removeClass('d-none')
      DOM_AddModalByModule.attr('data-target', '#RVD_ModalAdd')
      $("#RVD_ModuleTitle").html('Data Pesananan')
      DOM_SMOrder.on('click', ()=>{
        DOM_MOrder.removeClass('d-none')
        DOM_MStore.addClass('d-none')
        DOM_MCourier.addClass('d-none')
        DOM_AddModalByModule.attr('data-target', '#RVD_ModalAdd')
        $("#RVD_ModuleTitle").html('Data Pesananan')
      })

      DOM_SMStore.on('click', ()=>{
        DOM_MOrder.addClass('d-none')
        DOM_MStore.removeClass('d-none')
        DOM_MCourier.addClass('d-none')
        DOM_AddModalByModule.attr('data-target', '#RVD_ModalAddStore')
        $("#RVD_ModuleTitle").html('Data Toko')
      })

      DOM_SMCourier.on('click', ()=>{
        DOM_MOrder.addClass('d-none')
        DOM_MStore.addClass('d-none')
        DOM_MCourier.removeClass('d-none')
        DOM_AddModalByModule.attr('data-target', '#RVD_ModalAddCourier')
        $("#RVD_ModuleTitle").html('Data Kurir')
      })

      DOM_Scan.on('click', function(){
          DOM_Scan.toggleClass('active');
          DOM_ScanInput.toggleClass('d-none');
          DOM_ScanInput.focus();
          DOM_ScanInput.on('blur', function(e){
              $(this).focus();
          })
      });

      DOM_ModalAdd.on('shown.bs.modal', function(){
          DOM_ModalAdd.find("#input-name").val('');
          DOM_ModalAdd.find("#input-name").focus();
          fetch('http://localhost:8000/stores', {method: "GET"})
            .then(res_stores => res_stores.json())
            .then((json_stores) => {
                if(json_stores.draw === 0){
                    let datastores = json_stores.data,
                        optiontext = '',
                        domelem    = $('select.input-ecommerce');

                    domelem.empty()
                    datastores.forEach((item) => {
                        optiontext += '<option value="'+item.storeid+'" class="text-uppercase">'+item.storename+'</option>'
                    })
                    domelem.append(optiontext)
                }else{
                    FAlert('error','Ooppss..','error')
                }
            })

          fetch('http://localhost:8000/couriers', {method: "GET"})
            .then(res_couriers => res_couriers.json())
            .then((json_couriers) => {
                if(json_couriers.draw === 0){
                    let datacouriers = json_couriers.data,
                        optiontext = '',
                        domelem    = $('select.input-courier');

                    domelem.empty()
                    datacouriers.forEach((item) => {
                        optiontext += '<option value="'+item.courierid+'" class="text-uppercase">'+item.couriername+'</option>'
                    })
                    domelem.append(optiontext)
                }else{
                    FAlert('error','Ooppss..','error')
                }
            })
      });

      DOM_ModalAddStore.on('shown.bs.modal', () => {
          DOM_ModalAddStore.find("#input-name").val('');
          DOM_ModalAddStore.find("#input-name").focus();
      })

      DOM_ModalAddCourier.on('shown.bs.modal', () => {
          DOM_ModalAddCourier.find("#input-name").val('');
          DOM_ModalAddCourier.find("#input-name").focus();
      })

      DOM_ModalAdd.find('#RVD_Add').on('click', function(){
          let inputname = DOM_ModalAdd.find("#input-name"),
              inputinvoice = DOM_ModalAdd.find("#input-invoice"),
              inputbarcode = DOM_ModalAdd.find("#input-barcode"),
              inputproduct = DOM_ModalAdd.find("#input-descproduct"),
              inputdateorder    = DOM_ModalAdd.find("#input-dateorder"),
              inputcourier      = DOM_ModalAdd.find("#input-courier"),
              inputecommerce    = DOM_ModalAdd.find("#input-ecommerce"),
              inputcity    = DOM_ModalAdd.find("#input-city"),
              inputdateshipping = DOM_ModalAdd.find("#input-dateshipping"),
              inputfee  = DOM_ModalAdd.find("#input-fee"),
              inputphone    = DOM_ModalAdd.find("#input-phone");

          if(inputname.val() === ''){
              FAlert('error','Oooppss..','Input Nama tidak boleh kosong.', function(){
                  inputname.focus()
              })
          }else if(inputinvoice.val() === ''){
              FAlert('error','Oooppss..','Input Invoice tidak boleh kosong.', function(){
                  inputinvoice.focus()
              })
          }else if(inputproduct.val() === ''){
              FAlert('error','Oooppss..','Input Produk tidak boleh kosong.', function(){
                  inputproduct.focus()
              })
          }else{
              let paramqueryinput = {
                  descproduct: inputproduct.val(),
                  courier: inputcourier.val(),
                  name: inputname.val(),
                  city: inputcity.val() === '' ? null : inputcity.val(),
                  ecommerce: inputecommerce.val(),
                  fee: inputfee.val() === '' ? 0 : inputfee.val(),
                  invoice: inputinvoice.val(),
                  dateshipping: inputdateshipping.val() === '' ? null : inputdateshipping.val(),
                  dateorder: inputdateorder.val() === '' ? null : inputdateorder.val(),
                  barcode: inputbarcode.val() === '' ? null : inputbarcode.val(),
                  phone: inputphone.val() === '' ? null : inputphone.val()
              },
                  bodyparam = JSON.stringify({paraminput: paramqueryinput}),
                  headerparam = {
                      'Accept': 'application/json',
                      'Content-Type': 'application/json'
                  };

              fetch('http://localhost:8000/orders/add', {method: "POST", headers: headerparam, body: bodyparam})
                  .then(res_insert => res_insert.json())
                  .then((json_insert) => {
                      if(json_insert.status){
                          FAlert('success','Ok','Data berhasil ditambahkan.',false,1000)
                          DTB_Order.ajax.reload(null,false);
                      }else{
                          FAlert('error','Ooppss..',json_insert.message,false)
                      }
                      DOM_ModalAdd.modal('hide');
                  })
          }
      });

      DOM_ModalAddStore.find('#RVD_AddStore').on('click', ()=>{
          let inputname = DOM_ModalAddStore.find("#input-name")

          if(inputname.val() === ''){
              FAlert('error','Oooppss..','Input Nama tidak boleh kosong.', function(){
                  inputname.focus()
              })
          }else{
            let paramqueryinput = {paramname: inputname.val(),paramid: FSetRandomString(inputname.val(),3)},
                  bodyparam = JSON.stringify(paramqueryinput),
                  headerparam = {
                      'Accept': 'application/json',
                      'Content-Type': 'application/json'
                  };

              fetch('http://localhost:8000/stores/add', {method: "POST", headers: headerparam, body: bodyparam})
                  .then(res_insert => res_insert.json())
                  .then((json_insert) => {
                      if(json_insert.status){
                          FAlert('success','Ok','Data berhasil ditambahkan.',false,1000)
                          DTB_Store.ajax.reload(null,false);
                      }else{
                          FAlert('error','Ooppss..',json_insert.message,false)
                      }
                      DOM_ModalAddStore.modal('hide');
                  })
          }
      })

      DOM_ModalAddCourier.find('#RVD_AddCourier').on('click', ()=>{
          let inputname = DOM_ModalAddCourier.find("#input-name")

          if(inputname.val() === ''){
              FAlert('error','Oooppss..','Input Nama tidak boleh kosong.', function(){
                  inputname.focus()
              })
          }else{
            let paramqueryinput = {paramname: inputname.val(),paramid: FSetRandomString(inputname.val(),3)},
                  bodyparam = JSON.stringify(paramqueryinput),
                  headerparam = {
                      'Accept': 'application/json',
                      'Content-Type': 'application/json'
                  };

              fetch('http://localhost:8000/couriers/add', {method: "POST", headers: headerparam, body: bodyparam})
                  .then(res_insert => res_insert.json())
                  .then((json_insert) => {
                      if(json_insert.status){
                          FAlert('success','Ok','Data berhasil ditambahkan.',false,1000)
                          DTB_Courier.ajax.reload(null,false);
                      }else{
                          FAlert('error','Ooppss..',json_insert.message,false)
                      }
                      DOM_ModalAddCourier.modal('hide');
                  })
          }
      })

      DOM_Order.on('click','tbody tr',function(event) {
          event.preventDefault();
          let TBLength    = $('td', this).length,
              GetIndex    = $(event.target).index(),
              OriginData  = DTB_Order.row(this).data();

          if(TBLength > 1){

            fetch('http://localhost:8000/stores', {method: "GET"})
            .then(res_stores => res_stores.json())
            .then((json_stores) => {
                if(json_stores.draw === 0){
                    let datastores = json_stores.data,
                        optiontext = '',
                        domelem    = $('select.input-ecommerce');

                    domelem.empty()
                    datastores.forEach((item) => {
                        optiontext += '<option value="'+item.storeid+'" class="text-uppercase" '+(item.storeid === OriginData['storeid'] ? "selected":"")+'>'+item.storename+'</option>'
                    })
                    domelem.append(optiontext)
                }else{
                    FAlert('error','Ooppss..','error')
                }
            })

          fetch('http://localhost:8000/couriers', {method: "GET"})
            .then(res_couriers => res_couriers.json())
            .then((json_couriers) => {
                if(json_couriers.draw === 0){
                    let datacouriers = json_couriers.data,
                        optiontext = '',
                        domelem    = $('select.input-courier');

                    domelem.empty()
                    datacouriers.forEach((item) => {
                        optiontext += '<option value="'+item.courierid+'" class="text-uppercase" '+(item.courierid === OriginData['courierid'] ? "selected":"")+'>'+item.couriername+'</option>'
                    })
                    domelem.append(optiontext)
                }else{
                    FAlert('error','Ooppss..','error')
                }
            })


              DOM_ModalDetail.modal({backdrop: 'static', keyboard: false});
              DOM_ModalDetail.find("#input-name").val(OriginData['customer_name']);
              DOM_ModalDetail.find("#input-invoice").val(OriginData['invoice_number']);
              DOM_ModalDetail.find("#input-barcode").val(OriginData['barcode_number']);
              DOM_ModalDetail.find("#input-descproduct").val(OriginData['product_raw']);
              DOM_ModalDetail.find("#input-dateorder").val(OriginData['order_created_at']);
              DOM_ModalDetail.find(".input-courier").val(OriginData['courierid']).change();
              DOM_ModalDetail.find(".input-ecommerce").val(OriginData['storeid']).change();
              DOM_ModalDetail.find("#input-city").val(OriginData['city']);
              DOM_ModalDetail.find("#input-dateshipping").val(OriginData['shipping_date']);
              DOM_ModalDetail.find("#input-fee").val(OriginData['shipping_fee']);
              DOM_ModalDetail.find("#input-phone").val(OriginData['phone_number']);
              DOM_ModalDetail.find("#_orderid").val(OriginData['orderid']);
          }
      });

      DOM_Store.on('click','tbody tr',function(event) {
          event.preventDefault();
          let TBLength    = $('td', this).length,
              GetIndex    = $(event.target).index(),
              OriginData  = DTB_Store.row(this).data();

          if(TBLength > 1){
              DOM_ModalStoreDetail.modal({backdrop: 'static', keyboard: false});
              DOM_ModalStoreDetail.find("#input-name").val(OriginData['storename']);
              DOM_ModalStoreDetail.find("#_storeid").val(OriginData['storeid']);
          }
      });

      DOM_Courier.on('click','tbody tr',function(event) {
          event.preventDefault();
          let TBLength    = $('td', this).length,
              GetIndex    = $(event.target).index(),
              OriginData  = DTB_Courier.row(this).data();

          if(TBLength > 1){
              DOM_ModalCourierDetail.modal({backdrop: 'static', keyboard: false});
              DOM_ModalCourierDetail.find("#input-name").val(OriginData['couriername']);
              DOM_ModalCourierDetail.find("#_courierid").val(OriginData['courierid']);
          }
      });

      DOM_ModalDetail.find('#RVD_Update').on('click', function(){
          let inputname = DOM_ModalDetail.find("#input-name"),
              inputinvoice = DOM_ModalDetail.find("#input-invoice"),
              inputbarcode = DOM_ModalDetail.find("#input-barcode"),
              inputproduct = DOM_ModalDetail.find("#input-descproduct"),
              inputdateorder    = DOM_ModalDetail.find("#input-dateorder"),
              inputcourier      = DOM_ModalDetail.find(".input-courier"),
              inputecommerce    = DOM_ModalDetail.find(".input-ecommerce"),
              inputcity    = DOM_ModalDetail.find("#input-city"),
              inputdateshipping = DOM_ModalDetail.find("#input-dateshipping"),
              inputfee  = DOM_ModalDetail.find("#input-fee"),
              inputphone    = DOM_ModalDetail.find("#input-phone"),
              inputorderid  = DOM_ModalDetail.find("#_orderid");

          if(inputname.val() === ''){
              FAlert('error','Oooppss..','Input Nama tidak boleh kosong.', function(){
                  inputname.focus()
              })
          }else if(inputinvoice.val() === ''){
              FAlert('error','Oooppss..','Input Invoice tidak boleh kosong.', function(){
                  inputinvoice.focus()
              })
          }else if(inputproduct.val() === ''){
              FAlert('error','Oooppss..','Input Produk tidak boleh kosong.', function(){
                  inputproduct.focus()
              })
          }else{
              let paramqueryinput = {
                      descproduct: inputproduct.val(),
                      courier: inputcourier.val(),
                      name: inputname.val(),
                      city: inputcity.val() === '' ? null : inputcity.val(),
                      ecommerce: inputecommerce.val(),
                      fee: inputfee.val() === '' ? 0 : inputfee.val(),
                      invoice: inputinvoice.val(),
                      dateshipping: inputdateshipping.val() === '' ? null : inputdateshipping.val(),
                      dateorder: inputdateorder.val() === '' ? null : inputdateorder.val(),
                      barcode: inputbarcode.val() === '' ? null : inputbarcode.val(),
                      phone: inputphone.val() === '' ? null : inputphone.val(),
                      byorder: inputorderid.val() === '' ? null : inputorderid.val(),
                  },
                  bodyparam = JSON.stringify({paraminput: paramqueryinput}),
                  headerparam = {
                      'Accept': 'application/json',
                      'Content-Type': 'application/json'
                  };

              fetch('http://localhost:8000/orders/update', {method: "POST", headers: headerparam, body: bodyparam})
                  .then(res_update => res_update.json())
                  .then((json_update) => {
                      if(json_update.status){
                          FAlert('success','Ok','Data berhasil diperbarui.',false,1000)
                          DTB_Order.ajax.reload(null,false);
                      }else{
                          FAlert('error','Ooppss..',json_update.message,false)
                      }
                      DOM_ModalDetail.modal('hide');
                  })
          }
      });

      DOM_ModalStoreDetail.find('#RVD_UpdateStore').on('click', () => {
          let inputname = DOM_ModalStoreDetail.find("#input-name"),
              storeid = DOM_ModalStoreDetail.find("#_storeid");

          if(inputname.val() === ''){
              FAlert('error','Oooppss..','Input Nama tidak boleh kosong.', function(){
                  inputname.focus()
              })
          }else{
            let paramqueryinput = {paramname: inputname.val(),paramid: storeid.val()},
                  bodyparam = JSON.stringify(paramqueryinput),
                  headerparam = {
                      'Accept': 'application/json',
                      'Content-Type': 'application/json'
                  };

                fetch('http://localhost:8000/stores/update', {method: "POST", headers: headerparam, body: bodyparam})
                    .then(res_update => res_update.json())
                    .then((json_update) => {
                        if(json_update.status){
                            FAlert('success','Ok','Data berhasil diperbarui.',false,1000)
                            DTB_Store.ajax.reload(null,false);
                        }else{
                            FAlert('error','Ooppss..',json_update.message,false)
                        }
                        DOM_ModalStoreDetail.modal('hide');
                    })
          }
      })

      DOM_ModalCourierDetail.find('#RVD_UpdateCourier').on('click', () => {
          let inputname = DOM_ModalCourierDetail.find("#input-name"),
              courierid = DOM_ModalCourierDetail.find("#_courierid");

          if(inputname.val() === ''){
              FAlert('error','Oooppss..','Input Nama tidak boleh kosong.', function(){
                  inputname.focus()
              })
          }else{
            let paramqueryinput = {paramname: inputname.val(),paramid: courierid.val()},
                  bodyparam = JSON.stringify(paramqueryinput),
                  headerparam = {
                      'Accept': 'application/json',
                      'Content-Type': 'application/json'
                  };

                fetch('http://localhost:8000/couriers/update', {method: "POST", headers: headerparam, body: bodyparam})
                    .then(res_update => res_update.json())
                    .then((json_update) => {
                        if(json_update.status){
                            FAlert('success','Ok','Data berhasil diperbarui.',false,1000)
                            DTB_Courier.ajax.reload(null,false);
                        }else{
                            FAlert('error','Ooppss..',json_update.message,false)
                        }
                        DOM_ModalCourierDetail.modal('hide');
                    })
          }
      })

      DOM_Reset.on('click', () => {
        fetch('http://localhost:8000/reset', {method: "GET"})
        .then(res_reset => res_reset.json())
        .then((json_reset) => {
            if(json_reset.status){
                FAlert('success','Ok','Data berhasil di-reset.',false,1000)
                DTB_Order.ajax.reload(null,false);
            }else{
                FAlert('error','Ooppss..',json_reset.message,false)
            }
            DOM_ModalDetail.modal('hide');
        })
      })

      DOM_Import.on('click', function(){
        let formdata = new FormData(document.getElementById('RVD_FormImport'));
         fetch('http://localhost:8000/upload-excel', {method: "POST", body: formdata})
          .then(res_upload => res_upload.json())
          .then((json_upload) => {
            if(json_upload.status){
                FAlert('success','Ok','Data berhasil diperbarui.',false,1000)
                DTB_Order.ajax.reload(null,false);
            }else{
                FAlert('error','Ooppss..',json_upload.message,false)
            }
            DOM_ModalImport.modal('hide');
          }); 
      });

      DOM_ScanInput.on('input',function(){
          let bodyparam = JSON.stringify({code: $(this).val()}),
              headerparam = {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json'
              };

          fetch('http://localhost:8000/scan-barcode', {method: "POST", headers: headerparam, body: bodyparam})
            .then(res => res.json())
            .then((json) => {
              if(json.status){
                  if(json.match){
                      fetch('http://localhost:8000/set-is-scanned', {method: "POST", headers: headerparam, body: bodyparam})
                        .then(res_update => res_update.json())
                        .then((json_update) => {
                          if(json_update.status){
                              FAlert('success','Ok','Barcode sudah ditandai',function(){
                                  DOM_ScanInput.val('')
                                  DOM_ScanInput.focus()
                              }, 1000)
                              DTB_Order.ajax.reload(null,false);
                          }else{
                              FAlert('error','Ooppss..',json_update.message,function(){
                                  DOM_ScanInput.val('')
                                  DOM_ScanInput.focus()
                              }, 2000)
                          }
                      });
                  }else{
                      FAlert('warning','Ooppss..','Barcode tidak ditemukan',function(){
                          DOM_ScanInput.val('')
                          DOM_ScanInput.focus()
                      })
                  }
              }else{
                  FAlert('error','Ooppss..',json.message,function(){
                      DOM_ScanInput.val('')
                      DOM_ScanInput.focus()
                  })
              }
          });
      });

      DOM_Download.on('click', function(){
          fetch('http://localhost:8000/export-excel', {method: "get"})
              .then(res_download => res_download.json())
              .then((res_download) => {
                  if(res_download.status){
                      FAlert('success','Ok','Data berhasil disimpan di folder Report.',false,1000)
                  }else{
                      FAlert('error','Ooppss..',res_download.message,false)
                  }
              });
      })

      DOM_DTBRefresh.on('click', function(){
          window.location.reload()
      });

      DOM_Exit.on('click', function(){
          window.close();
      });
    </script>
  </body>
</html>